%-----------
% colours
%-----------
/black [0 0 0] def
/red [1 0 0] def
/green [0 1 0] def
/blue [0 0 1] def
/yellow [0.5 0.5 0] def
/orange [0.67 0.33 0] def
/purple [1 0 1] def
/cyan [0 1 1] def
/grey [0.7 0.7 0.7] def

%------------------
/setcolour
%------------------
% Input: A colour array [r g b].
{ aload pop setrgbcolor } def

%--------
/sq
%--------
% Returns the square of a number.
{ dup mul } def

/inches 72 def

/inches 72 def

%------------------
/page-begin 
%------------------
% Saves the previous graphics state, then sets up the co-ordinate system.
% Inputs: (1) Scale factor in inches, (2 & 3) position of origin in resulting scale from 
% bottom left.
% Output: The scale factor.
{
  5 dict begin
  				% stack: scale-factor xpos ypos
  3 2 roll			% stack: xpos ypos scale-factor
  /scale-factor exch def % stack: xpos ypos

  % Set up the co-ordinate system
  gsave
  /sc scale-factor inches mul def
  sc dup scale		% set the scale
  translate			% set the origin
  1 sc div setlinewidth	% set the line width to 1 point
  black setcolour		% set the colour to black

  sc				% return the scale factor

  end
} def

%------------------
/page-end 
%------------------
% Displays the page and restores the graphics state.
% Inputs: None
% Outputs: None
{
  showpage
  grestore
} def
